diff -Naur linux-2.6.11.8/fs/jffs2/zlib.h linux-2.6.x/fs/jffs2/zlib.h
--- linux-2.6.11.8/fs/jffs2/zlib.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/fs/jffs2/zlib.h	2009-09-06 22:42:40.000000000 +0100
@@ -0,0 +1,432 @@
+/*		*/
+
+/*
+ * This file is derived from zlib.h and zconf.h from the zlib-0.95
+ * distribution by Jean-loup Gailly and Mark Adler, with some additions
+ * by Paul Mackerras to aid in implementing Deflate compression and
+ * decompression for PPP packets.
+ */
+
+/*
+ *  ==FILEVERSION 960122==
+ *
+ * This marker is used by the Linux installation script to determine
+ * whether an up-to-date version of this file is already installed.
+ */
+
+/* zlib.h -- interface of the 'zlib' general purpose compression library
+  version 0.95, Aug 16th, 1995.
+
+  Copyright (C) 1995 Jean-loup Gailly and Mark Adler
+
+  This software is provided 'as-is', without any express or implied
+  warranty.  In no event will the authors be held liable for any damages
+  arising from the use of this software.
+
+  Permission is granted to anyone to use this software for any purpose,
+  including commercial applications, and to alter it and redistribute it
+  freely, subject to the following restrictions:
+
+  1. The origin of this software must not be misrepresented; you must not
+     claim that you wrote the original software. If you use this software
+     in a product, an acknowledgment in the product documentation would be
+     appreciated but is not required.
+  2. Altered source versions must be plainly marked as such, and must not be
+     misrepresented as being the original software.
+  3. This notice may not be removed or altered from any source distribution.
+
+  Jean-loup Gailly        Mark Adler
+  gzip@prep.ai.mit.edu    madler@alumni.caltech.edu
+ */
+
+#ifndef _ZLIB_H
+#define _ZLIB_H
+
+/* #include "zconf.h" */	/* included directly here */
+
+/* zconf.h -- configuration of the zlib compression library
+ * Copyright (C) 1995 Jean-loup Gailly.
+ * For conditions of distribution and use, see copyright notice in zlib.h 
+ */
+
+/* From: zconf.h,v 1.12 1995/05/03 17:27:12 jloup Exp */
+
+/*
+     The library does not install any signal handler. It is recommended to
+  add at least a handler for SIGSEGV when decompressing; the library checks
+  the consistency of the input data whenever possible but may go nuts
+  for some forms of corrupted input.
+ */
+
+/*
+ * Compile with -DMAXSEG_64K if the alloc function cannot allocate more
+ * than 64k bytes at a time (needed on systems with 16-bit int).
+ * Compile with -DUNALIGNED_OK if it is OK to access shorts or ints
+ * at addresses which are not a multiple of their size.
+ * Under DOS, -DFAR=far or -DFAR=__far may be needed.
+ */
+
+#ifndef STDC
+#  if defined(MSDOS) || defined(__STDC__) || defined(__cplusplus)
+#    define STDC
+#  endif
+#endif
+
+#ifdef	__MWERKS__ /* Metrowerks CodeWarrior declares fileno() in unix.h */
+#  include <unix.h>
+#endif
+
+/* Maximum value for memLevel in deflateInit2 */
+#ifndef MAX_MEM_LEVEL
+#  ifdef MAXSEG_64K
+#    define MAX_MEM_LEVEL 8
+#  else
+#    define MAX_MEM_LEVEL 9
+#  endif
+#endif
+
+#ifndef FAR
+#  define FAR
+#endif
+
+/* Maximum value for windowBits in deflateInit2 and inflateInit2 */
+#ifndef MAX_WBITS
+#  define MAX_WBITS   15 /* 32K LZ77 window */
+#endif
+
+/* The memory requirements for deflate are (in bytes):
+            1 << (windowBits+2)   +  1 << (memLevel+9)
+ that is: 128K for windowBits=15  +  128K for memLevel = 8  (default values)
+ plus a few kilobytes for small objects. For example, if you want to reduce
+ the default memory requirements from 256K to 128K, compile with
+     make CFLAGS="-O -DMAX_WBITS=14 -DMAX_MEM_LEVEL=7"
+ Of course this will generally degrade compression (there's no free lunch).
+
+   The memory requirements for inflate are (in bytes) 1 << windowBits
+ that is, 32K for windowBits=15 (default value) plus a few kilobytes
+ for small objects.
+*/
+
+                        /* Type declarations */
+
+#ifndef OF /* function prototypes */
+#  ifdef STDC
+#    define OF(args)  args
+#  else
+#    define OF(args)  ()
+#  endif
+#endif
+
+typedef unsigned char  Byte;  /* 8 bits */
+typedef unsigned int   uInt;  /* 16 bits or more */
+typedef unsigned long  uLong; /* 32 bits or more */
+
+typedef Byte FAR Bytef;
+typedef char FAR charf;
+typedef int FAR intf;
+typedef uInt FAR uIntf;
+typedef uLong FAR uLongf;
+
+#ifdef STDC
+   typedef void FAR *voidpf;
+   typedef void     *voidp;
+#else
+   typedef Byte FAR *voidpf;
+   typedef Byte     *voidp;
+#endif
+
+/* end of original zconf.h */
+
+#define ZLIB_VERSION "0.95P"
+
+/* 
+     The 'zlib' compression library provides in-memory compression and
+  decompression functions, including integrity checks of the uncompressed
+  data.  This version of the library supports only one compression method
+  (deflation) but other algorithms may be added later and will have the same
+  stream interface.
+
+     For compression the application must provide the output buffer and
+  may optionally provide the input buffer for optimization. For decompression,
+  the application must provide the input buffer and may optionally provide
+  the output buffer for optimization.
+
+     Compression can be done in a single step if the buffers are large
+  enough (for example if an input file is mmap'ed), or can be done by
+  repeated calls of the compression function.  In the latter case, the
+  application must provide more input and/or consume the output
+  (providing more output space) before each call.
+*/
+
+typedef voidpf (*alloc_func) OF((voidpf opaque, uInt items, uInt size));
+typedef void   (*free_func)  OF((voidpf opaque, voidpf address, uInt nbytes));
+
+struct internal_state;
+
+typedef struct z_stream_s {
+    Bytef    *next_in;  /* next input byte */
+    uInt     avail_in;  /* number of bytes available at next_in */
+    uLong    total_in;  /* total nb of input bytes read so far */
+
+    Bytef    *next_out; /* next output byte should be put there */
+    uInt     avail_out; /* remaining free space at next_out */
+    uLong    total_out; /* total nb of bytes output so far */
+
+    char     *msg;      /* last error message, NULL if no error */
+    struct internal_state FAR *state; /* not visible by applications */
+
+    alloc_func zalloc;  /* used to allocate the internal state */
+    free_func  zfree;   /* used to free the internal state */
+    voidp      opaque;  /* private data object passed to zalloc and zfree */
+
+    Byte     data_type; /* best guess about the data type: ascii or binary */
+
+} z_stream;
+
+/*
+   The application must update next_in and avail_in when avail_in has
+   dropped to zero. It must update next_out and avail_out when avail_out
+   has dropped to zero. The application must initialize zalloc, zfree and
+   opaque before calling the init function. All other fields are set by the
+   compression library and must not be updated by the application.
+
+   The opaque value provided by the application will be passed as the first
+   parameter for calls of zalloc and zfree. This can be useful for custom
+   memory management. The compression library attaches no meaning to the
+   opaque value.
+
+   zalloc must return Z_NULL if there is not enough memory for the object.
+   On 16-bit systems, the functions zalloc and zfree must be able to allocate
+   exactly 65536 bytes, but will not be required to allocate more than this
+   if the symbol MAXSEG_64K is defined (see zconf.h). WARNING: On MSDOS,
+   pointers returned by zalloc for objects of exactly 65536 bytes *must*
+   have their offset normalized to zero. The default allocation function
+   provided by this library ensures this (see zutil.c). To reduce memory
+   requirements and avoid any allocation of 64K objects, at the expense of
+   compression ratio, compile the library with -DMAX_WBITS=14 (see zconf.h).
+
+   The fields total_in and total_out can be used for statistics or
+   progress reports. After compression, total_in holds the total size of
+   the uncompressed data and may be saved for use in the decompressor
+   (particularly if the decompressor wants to decompress everything in
+   a single step).
+*/
+
+                        /* constants */
+
+#define Z_NO_FLUSH      0
+#define Z_PARTIAL_FLUSH 1
+#define Z_FULL_FLUSH    2
+#define Z_SYNC_FLUSH    3 /* experimental: partial_flush + byte align */
+#define Z_FINISH        4
+#define Z_PACKET_FLUSH	5
+/* See deflate() below for the usage of these constants */
+
+#define Z_OK            0
+#define Z_STREAM_END    1
+#define Z_ERRNO        (-1)
+#define Z_STREAM_ERROR (-2)
+#define Z_DATA_ERROR   (-3)
+#define Z_MEM_ERROR    (-4)
+#define Z_BUF_ERROR    (-5)
+/* error codes for the compression/decompression functions */
+
+#define Z_BEST_SPEED             1
+#define Z_BEST_COMPRESSION       9
+#define Z_DEFAULT_COMPRESSION  (-1)
+/* compression levels */
+
+#define Z_FILTERED            1
+#define Z_HUFFMAN_ONLY        2
+#define Z_DEFAULT_STRATEGY    0
+
+#define Z_BINARY   0
+#define Z_ASCII    1
+#define Z_UNKNOWN  2
+/* Used to set the data_type field */
+
+#define Z_NULL  0  /* for initializing zalloc, zfree, opaque */
+
+extern char *zlib_version;
+/* The application can compare zlib_version and ZLIB_VERSION for consistency.
+   If the first character differs, the library code actually used is
+   not compatible with the zlib.h header file used by the application.
+ */
+
+                        /* basic functions */
+
+extern int inflateInit OF((z_stream *strm));
+/* 
+     Initializes the internal stream state for decompression. The fields
+   zalloc and zfree must be initialized before by the caller.  If zalloc and
+   zfree are set to Z_NULL, inflateInit updates them to use default allocation
+   functions.
+
+     inflateInit returns Z_OK if success, Z_MEM_ERROR if there was not
+   enough memory.  msg is set to null if there is no error message.
+   inflateInit does not perform any decompression: this will be done by
+   inflate().
+*/
+
+
+extern int inflate OF((z_stream *strm, int flush));
+/*
+  Performs one or both of the following actions:
+
+  - Decompress more input starting at next_in and update next_in and avail_in
+    accordingly. If not all input can be processed (because there is not
+    enough room in the output buffer), next_in is updated and processing
+    will resume at this point for the next call of inflate().
+
+  - Provide more output starting at next_out and update next_out and avail_out
+    accordingly.  inflate() always provides as much output as possible
+    (until there is no more input data or no more space in the output buffer).
+
+  Before the call of inflate(), the application should ensure that at least
+  one of the actions is possible, by providing more input and/or consuming
+  more output, and updating the next_* and avail_* values accordingly.
+  The application can consume the uncompressed output when it wants, for
+  example when the output buffer is full (avail_out == 0), or after each
+  call of inflate().
+
+    If the parameter flush is set to Z_PARTIAL_FLUSH or Z_PACKET_FLUSH,
+  inflate flushes as much output as possible to the output buffer. The
+  flushing behavior of inflate is not specified for values of the flush
+  parameter other than Z_PARTIAL_FLUSH, Z_PACKET_FLUSH or Z_FINISH, but the
+  current implementation actually flushes as much output as possible
+  anyway.  For Z_PACKET_FLUSH, inflate checks that once all the input data
+  has been consumed, it is expecting to see the length field of a stored
+  block; if not, it returns Z_DATA_ERROR.
+
+    inflate() should normally be called until it returns Z_STREAM_END or an
+  error. However if all decompression is to be performed in a single step
+  (a single call of inflate), the parameter flush should be set to
+  Z_FINISH. In this case all pending input is processed and all pending
+  output is flushed; avail_out must be large enough to hold all the
+  uncompressed data. (The size of the uncompressed data may have been saved
+  by the compressor for this purpose.) The next operation on this stream must
+  be inflateEnd to deallocate the decompression state. The use of Z_FINISH
+  is never required, but can be used to inform inflate that a faster routine
+  may be used for the single inflate() call.
+
+    inflate() returns Z_OK if some progress has been made (more input
+  processed or more output produced), Z_STREAM_END if the end of the
+  compressed data has been reached and all uncompressed output has been
+  produced, Z_DATA_ERROR if the input data was corrupted, Z_STREAM_ERROR if
+  the stream structure was inconsistent (for example if next_in or next_out
+  was NULL), Z_MEM_ERROR if there was not enough memory, Z_BUF_ERROR if no
+  progress is possible or if there was not enough room in the output buffer
+  when Z_FINISH is used. In the Z_DATA_ERROR case, the application may then
+  call inflateSync to look for a good compression block.  */
+
+
+extern int inflateEnd OF((z_stream *strm));
+/*
+     All dynamically allocated data structures for this stream are freed.
+   This function discards any unprocessed input and does not flush any
+   pending output.
+
+     inflateEnd returns Z_OK if success, Z_STREAM_ERROR if the stream state
+   was inconsistent. In the error case, msg may be set but then points to a
+   static string (which must not be deallocated).
+*/
+
+                        /* advanced functions */
+
+extern int inflateInit2 OF((z_stream *strm,
+                            int  windowBits));
+/*   
+     This is another version of inflateInit with more compression options. The
+   fields next_out, zalloc and zfree must be initialized before by the caller.
+
+     The windowBits parameter is the base two logarithm of the maximum window
+   size (the size of the history buffer).  It should be in the range 8..15 for
+   this version of the library (the value 16 will be allowed soon). The
+   default value is 15 if inflateInit is used instead. If a compressed stream
+   with a larger window size is given as input, inflate() will return with
+   the error code Z_DATA_ERROR instead of trying to allocate a larger window.
+
+     If next_out is not null, the library will use this buffer for the history
+   buffer; the buffer must either be large enough to hold the entire output
+   data, or have at least 1<<windowBits bytes.  If next_out is null, the
+   library will allocate its own buffer (and leave next_out null). next_in
+   need not be provided here but must be provided by the application for the
+   next call of inflate().
+
+     If the history buffer is provided by the application, next_out must
+   never be changed by the application since the decompressor maintains
+   history information inside this buffer from call to call; the application
+   can only reset next_out to the beginning of the history buffer when
+   avail_out is zero and all output has been consumed.
+
+      inflateInit2 returns Z_OK if success, Z_MEM_ERROR if there was
+   not enough memory, Z_STREAM_ERROR if a parameter is invalid (such as
+   windowBits < 8). msg is set to null if there is no error message.
+   inflateInit2 does not perform any decompression: this will be done by
+   inflate().
+*/
+
+extern int inflateSync OF((z_stream *strm));
+/* 
+    Skips invalid compressed data until the special marker (see deflate()
+  above) can be found, or until all available input is skipped. No output
+  is provided.
+
+    inflateSync returns Z_OK if the special marker has been found, Z_BUF_ERROR
+  if no more input was provided, Z_DATA_ERROR if no marker has been found,
+  or Z_STREAM_ERROR if the stream structure was inconsistent. In the success
+  case, the application may save the current current value of total_in which
+  indicates where valid compressed data was found. In the error case, the
+  application may repeatedly call inflateSync, providing more input each time,
+  until success or end of the input data.
+*/
+
+extern int inflateReset OF((z_stream *strm));
+/*
+     This function is equivalent to inflateEnd followed by inflateInit,
+   but does not free and reallocate all the internal decompression state.
+   The stream will keep attributes that may have been set by inflateInit2.
+
+      inflateReset returns Z_OK if success, or Z_STREAM_ERROR if the source
+   stream state was inconsistent (such as zalloc or state being NULL).
+*/
+
+extern int inflateIncomp OF((z_stream *strm));
+/*
+     This function adds the data at next_in (avail_in bytes) to the output
+   history without performing any output.  There must be no pending output,
+   and the decompressor must be expecting to see the start of a block.
+   Calling this function is equivalent to decompressing a stored block
+   containing the data at next_in (except that the data is not output).
+*/
+
+                        /* checksum functions */
+
+/*
+     This function is not related to compression but is exported
+   anyway because it might be useful in applications using the
+   compression library.
+*/
+
+extern uLong adler32 OF((uLong adler, Bytef *buf, uInt len));
+
+/*
+     Update a running Adler-32 checksum with the bytes buf[0..len-1] and
+   return the updated checksum. If buf is NULL, this function returns
+   the required initial value for the checksum.
+   An Adler-32 checksum is almost as reliable as a CRC32 but can be computed
+   much faster. Usage example:
+
+     uLong adler = adler32(0L, Z_NULL, 0);
+
+     while (read_buffer(buffer, length) != EOF) {
+       adler = adler32(adler, buffer, length);
+     }
+     if (adler != original_adler) error();
+*/
+
+#ifndef _Z_UTIL_H
+    struct internal_state {int dummy;}; /* hack for buggy compilers */
+#endif
+
+#endif /* _ZLIB_H */
diff -Naur linux-2.6.11.8/fs/proc/proc_misc.c linux-2.6.x/fs/proc/proc_misc.c
--- linux-2.6.11.8/fs/proc/proc_misc.c	2005-04-30 02:24:07.000000000 +0100
+++ linux-2.6.x/fs/proc/proc_misc.c	2009-09-06 22:42:40.000000000 +0100
@@ -304,6 +304,8 @@
 };
 #endif
 
+
+#ifdef CONFIG_SLAB
 extern struct seq_operations slabinfo_op;
 extern ssize_t slabinfo_write(struct file *, const char __user *, size_t, loff_t *);
 static int slabinfo_open(struct inode *inode, struct file *file)
@@ -317,6 +319,7 @@
 	.llseek		= seq_lseek,
 	.release	= seq_release,
 };
+#endif
 
 static int show_stat(struct seq_file *p, void *v)
 {
@@ -581,7 +584,9 @@
 	create_seq_entry("partitions", 0, &proc_partitions_operations);
 	create_seq_entry("stat", 0, &proc_stat_operations);
 	create_seq_entry("interrupts", 0, &proc_interrupts_operations);
+#ifdef CONFIG_SLAB	
 	create_seq_entry("slabinfo",S_IWUSR|S_IRUGO,&proc_slabinfo_operations);
+#endif	
 	create_seq_entry("buddyinfo",S_IRUGO, &fragmentation_file_operations);
 	create_seq_entry("vmstat",S_IRUGO, &proc_vmstat_file_operations);
 	create_seq_entry("diskstats", 0, &proc_diskstats_operations);
diff -Naur linux-2.6.11.8/include/asm-arm/arch-actelm7/actelm7.h linux-2.6.x/include/asm-arm/arch-actelm7/actelm7.h
--- linux-2.6.11.8/include/asm-arm/arch-actelm7/actelm7.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/include/asm-arm/arch-actelm7/actelm7.h	2009-09-06 22:44:04.000000000 +0100
@@ -0,0 +1,73 @@
+/*
+ *  linux/include/asm-arm/arch-actelm7/actelm7.h
+ */
+
+#ifndef __ASM_ARCH_actelm7_H
+#define __ASM_ARCH_actelm7_H
+
+/* Vectored Interrupt Controller (VIC) */
+#define IRQStatus	(*((volatile unsigned char *) 0x2400002c))
+#define FIQStatus       (*((volatile unsigned char *) 0x24000014))
+#define IRQRawStatus    (*((volatile unsigned char *) 0x24000028))
+#define IRQEnable	(*((volatile unsigned char *) 0x24000020))
+#define IRQEnableClear  (*((volatile unsigned char *) 0x24000024))
+#define IRQSoftInt      (*((volatile unsigned char *) 0x24000018))
+#define IRQSoftIntClear (*((volatile unsigned char *) 0x2400001C))
+
+//* General Purpose Input/Output (GPIO) */
+
+#define DataOut         (*((volatile unsigned long *) 0x20000000))
+#define DataIn          (*((volatile unsigned long *) 0x20000000))
+
+/* Universal Asynchronous Receiver Transmitter 0 (UART0) */
+#define U0RBR           (*((volatile unsigned char *) 0x22000000))
+#define U0THR           (*((volatile unsigned char *) 0x22000000))
+#define U0IER           (*((volatile unsigned char *) 0x22000004))
+#define U0IIR           (*((volatile unsigned char *) 0x22000008))
+#define U0FCR           (*((volatile unsigned char *) 0x22000008))
+#define U0LCR           (*((volatile unsigned char *) 0x2200000C))
+#define U0MCR		(*((volatile unsigned char *) 0x22000010))
+#define U0LSR           (*((volatile unsigned char *) 0x22000014))
+#define U0SCR           (*((volatile unsigned char *) 0x2200001C))
+#define U0DLL           (*((volatile unsigned char *) 0x22000000))
+#define U0DLM           (*((volatile unsigned char *) 0x22000004))
+
+/* SPI (Serial Peripheral Interface) */
+
+#define SPI_TX          (*((volatile unsigned char *) 0x25000000))
+#define SPI_RX		(*((volatile unsigned char *) 0x25000000))
+#define SPI_CTRL1       (*((volatile unsigned char *) 0x25000004))
+#define SPI_CTRL2       (*((volatile unsigned char *) 0x25000008))
+#define SPI_STATUS      (*((volatile unsigned char *) 0x25000008))
+#define SPI_SLAVE	(*((volatile unsigned char *) 0x2500000c))
+
+/* Timer 0 */
+#define T0_INT_CLR      (*((volatile unsigned long *) 0x21000010))
+#define T0_TCR          (*((volatile unsigned long *) 0x21000008))
+#define T0_TLR          (*((volatile unsigned long *) 0x21000000))
+#define T0_PR           (*((volatile unsigned long *) 0x2100000C))
+#define T0_VALUE        (*((volatile unsigned long *) 0x21000004))
+#define T0_MIS          (*((volatile unsigned long *) 0x21000018))
+
+/* Watchdog */
+#define WDT_LOAD        (*((volatile unsigned long *) 0x23000000))
+#define WDT_VALUE       (*((volatile unsigned long *) 0x23000004))
+#define WDT_CNTR        (*((volatile unsigned long *) 0x23000008))
+#define WDT_REFRESH     (*((volatile unsigned long *) 0x2300000C))
+
+/* I2C */
+
+#define I2C_CNTR	(*((volatile unsigned char *) 0x26000000))
+#define I2C_STATUS	(*((volatile unsigned char *) 0x26000004))
+#define I2C_DATA	(*((volatile unsigned char *) 0x26000008))
+#define I2C_ADDR0	(*((volatile unsigned char *) 0x2600000C))
+#define I2C_SMB		(*((volatile unsigned char *) 0x26000010))
+#define I2C_ADDR1	(*((volatile unsigned char *) 0x2600001C))
+
+#define	actelm7_Fcclk	CONFIG_ARM_CLK  /* system clk frequecy,<=30Mhz, defined in system configuration */
+#define actelm7_Fpclk	(actelm7_Fcclk) /* used for pclk */
+
+#endif
+/*********************************************************************************************************
+**                            End Of File
+********************************************************************************************************/
diff -Naur linux-2.6.11.8/include/asm-arm/arch-actelm7/dma.h linux-2.6.x/include/asm-arm/arch-actelm7/dma.h
--- linux-2.6.11.8/include/asm-arm/arch-actelm7/dma.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/include/asm-arm/arch-actelm7/dma.h	2009-09-06 22:42:40.000000000 +0100
@@ -0,0 +1,24 @@
+/*
+ * linux/include/asm-armnommu/arch-actelm7/dma.h
+ */
+
+#include <linux/config.h>
+#include <asm/hardware.h>
+#include <linux/wait.h>
+
+#ifndef __ASM_actelm7_ARCH_DMA_H
+#define __ASM_actelm7_ARCH_DMA_H
+
+/*
+ * This is the maximum DMA address(physical address) that can be DMAd to.
+ * 
+ */
+#define MAX_DMA_ADDRESS		0xffffffff  /* used in alloc_bootmem,see linux/bootmem.h*/
+
+/*
+ * Actelm7 has no DMA channels.
+ */
+#define MAX_DMA_CHANNELS	0		/* actelm7 has no dma */    
+
+#endif /* _ASM_actelm7_ARCH_DMA_H */
+
diff -Naur linux-2.6.11.8/include/asm-arm/arch-actelm7/entry-macro.S linux-2.6.x/include/asm-arm/arch-actelm7/entry-macro.S
--- linux-2.6.11.8/include/asm-arm/arch-actelm7/entry-macro.S	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/include/asm-arm/arch-actelm7/entry-macro.S	2009-09-06 22:42:40.000000000 +0100
@@ -0,0 +1,32 @@
+/*
+ *  include/arm/arch-actelm7/entry-macro.S
+ *
+ *  defines machine dependent entry macros.
+ *  included in the arch/armnommu/kernel/entry.S
+ *  
+ */
+.EQU	IrqStatus,	0x2400002C
+
+#if defined(CONFIG_ARCH_ACTELM7)
+        .macro  disable_fiq
+        .endm
+
+		.macro get_irqnr_and_base, irqnr, irqstat, base, tmp
+		
+		ldr	\irqstat, =(IrqStatus)	@ load address of interrupt pending
+		ldr	\irqstat, [\irqstat]	@ get the register content
+
+		mov     \irqnr, #0
+1001:
+		tst     \irqstat, #1
+		bne     1002f
+		add     \irqnr, \irqnr, #1
+		mov     \irqstat, \irqstat, lsr #1
+		cmp     \irqnr, #NR_IRQS
+		bcc     1001b
+1002:		/* EQ will be set if we reach 32 */
+		.endm
+
+		.macro irq_prio_table
+		.endm
+#endif
diff -Naur linux-2.6.11.8/include/asm-arm/arch-actelm7/hardware.h linux-2.6.x/include/asm-arm/arch-actelm7/hardware.h
--- linux-2.6.11.8/include/asm-arm/arch-actelm7/hardware.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/include/asm-arm/arch-actelm7/hardware.h	2009-09-06 22:42:40.000000000 +0100
@@ -0,0 +1,28 @@
+/*
+ *  linux/include/asm-arm/arch-actelm7/hardware.h
+ */
+#ifndef __ASM_ARCH_HARDWARE_H
+#define __ASM_ARCH_HARDWARE_H
+
+#include <asm/arch/sizes.h>
+#include <asm/arch/actelm7.h>
+
+#ifndef __ASSEMBLY__
+
+#define HARD_RESET_NOW()
+
+/* the machine dependent  bootmem reserve and free routines */
+#define MACH_RESERVE_BOOTMEM()
+
+#define MACH_FREE_BOOTMEM()
+
+/* yes, freeing initmem is okay */
+#define DO_FREE_INITMEM() 	(1)
+
+#endif
+
+#define actelm7_MEM_SIZE     (CONFIG_DRAM_SIZE) 
+#define MEM_SIZE             actelm7_MEM_SIZE
+#define PA_SDRAM_BASE        CONFIG_DRAM_BASE
+
+#endif  /*   END OF __ASM_ARCH_HARDWARE_H */
diff -Naur linux-2.6.11.8/include/asm-arm/arch-actelm7/io.h linux-2.6.x/include/asm-arm/arch-actelm7/io.h
--- linux-2.6.11.8/include/asm-arm/arch-actelm7/io.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/include/asm-arm/arch-actelm7/io.h	2009-09-06 22:42:40.000000000 +0100
@@ -0,0 +1,63 @@
+/*
+ *  linux/include/asm-arm/arch-actelm7/io.h
+ */
+#ifndef __ASM_ARM_ARCH_IO_H
+#define __ASM_ARM_ARCH_IO_H
+
+#define IO_SPACE_LIMIT 0xffffffff
+/* Used in kernel/resource.c */
+
+/*
+ * We have the this routine to use usb host device driver
+ */
+
+
+#define PCI_IO_VADDR      (0x0)
+#define PCI_MEMORY_VADDR  (0x0)
+
+#define __io(a)			(PCI_IO_VADDR + (a))
+#define __mem_pci(a)		((unsigned long)(a))
+#define __mem_isa(a)		(PCI_MEMORY_VADDR + (unsigned long)(a))
+
+
+/*
+ * These macros were copied from arch/armnommu/io.h and are used instead
+ * of the definitions found there, because we want to do 16/32 bit i/o
+ * without byte swapping.
+ * --the
+ */
+
+#undef __io
+
+#ifndef __iob
+  #define __iob(a) __io(a)
+#endif
+
+#define outb(v,p)       __raw_writeb(v, p)
+#define outw(v,p)       __raw_writew(v, p)
+#define outl(v,p)       __raw_writel(v, p)
+
+#define inb(p)          ({ unsigned int __v = __raw_readb(p); __v; })
+#define inw(p)          ({ unsigned int __v = __raw_readw(p); __v; })
+#define inl(p)          ({ unsigned int __v = __raw_readl(p); __v; })
+
+#define outsb(p,d,l)    __raw_writesb(p, d, l)
+#define outsw(p,d,l)    __raw_writesw(p, d, l)
+#define outsl(p,d,l)    __raw_writesl(p, d, l)
+
+#define insb(p,d,l)     __raw_readsb(p, d, l)
+#define insw(p,d,l)     __raw_readsw(p, d, l)
+#define insl(p,d,l)     __raw_readsl(p, d, l)
+
+/*
+ * Validate the pci memory address for ioremap.
+ */
+#define iomem_valid_addr(iomem,size)	(1)
+
+
+/*
+ * Convert PCI memory space to a CPU physical address
+ */
+#define iomem_to_phys(iomem)	(iomem)
+
+#endif
diff -Naur linux-2.6.11.8/include/asm-arm/arch-actelm7/irq.h linux-2.6.x/include/asm-arm/arch-actelm7/irq.h
--- linux-2.6.11.8/include/asm-arm/arch-actelm7/irq.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/include/asm-arm/arch-actelm7/irq.h	2009-09-06 22:42:40.000000000 +0100
@@ -0,0 +1,20 @@
+/*
+ *  linux/include/asm-arm/arch-actelm7/irq.h
+ */
+#ifndef __actelm7_irq_h
+#define __actelm7_irq_h
+
+#include <asm/hardware.h>
+#include <asm/io.h>
+#include <asm/mach/irq.h>
+#include <asm/arch/irqs.h>
+
+extern unsigned  int fixup_irq(int i);
+
+extern void do_IRQ(int irq, struct pt_regs *regs);
+
+extern void actelm7_init_irq(void);
+
+#define 	irq_init_irq 	actelm7_init_irq
+
+#endif 
diff -Naur linux-2.6.11.8/include/asm-arm/arch-actelm7/irqs.h linux-2.6.x/include/asm-arm/arch-actelm7/irqs.h
--- linux-2.6.11.8/include/asm-arm/arch-actelm7/irqs.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/include/asm-arm/arch-actelm7/irqs.h	2009-09-06 22:42:40.000000000 +0100
@@ -0,0 +1,19 @@
+/*
+ *  linux/include/asm-arm/arch-actelm7/irqs.h
+ *
+ *  IRQ number definition
+ *  All IRQ numbers of the actelm7 CPUs.
+ *
+ */
+
+#ifndef __actelm7_irqs_h
+#define __actelm7_irqs_h                        1
+
+#define NR_IRQS		4
+	
+#define ACTELM7_INTERRUPT_TIMER0  0	/* Timer 0 */
+#define ACTELM7_INTERRUPT_UART0	  1	/* UART 0 */
+#define ACTELM7_INTERRUPT_SPI0 	  2	/* SPI0 */
+#define ACTELM7_INTERRUPT_PENDOWN 3     /* ADS7864 */
+
+#endif /* End of __irqs_h */
diff -Naur linux-2.6.11.8/include/asm-arm/arch-actelm7/keyboard.h linux-2.6.x/include/asm-arm/arch-actelm7/keyboard.h
--- linux-2.6.11.8/include/asm-arm/arch-actelm7/keyboard.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/include/asm-arm/arch-actelm7/keyboard.h	2009-09-06 22:42:40.000000000 +0100
@@ -0,0 +1,16 @@
+/*
+ *  linux/include/asm-arm/arch-actelm7/keyboard.h
+ */
+#ifndef __ASM_ARMNOMMU_ARCH_actelm7_KEYBOARD_H
+#define __ASM_ARMNOMMU_ARCH_actelm7_KEYBOARD_H
+
+#define kbd_setkeycode(sc,kc) (-EINVAL)
+#define kbd_getkeycode(sc) (-EINVAL)
+#define kbd_translate(sc,kcp,rm) ({ *(kcp) = (sc); 1; })
+#define kbd_unexpected_up(kc) (0200)
+#define kbd_leds(leds)
+#define kbd_init_hw()
+#define kbd_enable_irq()
+#define kbd_disable_irq()
+
+#endif /* __ASM_ARMNOMMU_ARCH_actelm7_KEYBOARD_H */
diff -Naur linux-2.6.11.8/include/asm-arm/arch-actelm7/memory.h linux-2.6.x/include/asm-arm/arch-actelm7/memory.h
--- linux-2.6.11.8/include/asm-arm/arch-actelm7/memory.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/include/asm-arm/arch-actelm7/memory.h	2009-09-06 22:42:40.000000000 +0100
@@ -0,0 +1,23 @@
+/*
+ * linux/include/asm-arm/arch-actelm7/memory.h
+ */
+
+#ifndef __ASM_ARCH_MEMORY_H
+#define __ASM_ARCH_MEMORY_H
+
+#include <linux/config.h>
+
+#define TASK_SIZE	(0x80100000)	
+#define TASK_SIZE_26	TASK_SIZE
+#define TASK_UNMAPPED_BASE	(0x0)	
+
+#define PHYS_OFFSET	(CONFIG_DRAM_BASE)
+#define PAGE_OFFSET 	(PHYS_OFFSET)
+#define END_MEM     	(CONFIG_DRAM_BASE + CONFIG_DRAM_SIZE)
+
+#define __virt_to_phys(vpage) ((unsigned long) (vpage))
+#define __phys_to_virt(ppage) ((void *) (ppage))
+#define __virt_to_bus(vpage) ((unsigned long) (vpage))
+#define __bus_to_virt(ppage) ((void *) (ppage))
+
+#endif /*  __ASM_ARCH_MEMORY_H */
